﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using Telerik.Windows.Input;

namespace NewNodeExample
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();
			this.treeView1.ItemsSource = new FoldersAndFiles();
		}

		private void AddFileButton_Click(object sender, RoutedEventArgs e)
		{
			this.AddItem<File>();
		}

		private void AddFolder_Click(object sender, RoutedEventArgs e)
		{
			this.AddItem<Folder>();
		}

		private void AddItem<T>() where T : BaseItem, new()
		{
			if (this.treeView1.SelectedItem != null && this.treeView1.SelectedItem is Folder)
			{
				Folder selectedFolder = this.treeView1.SelectedItem as Folder;

				T newItem = new T()
				{
					Name = "New Item",
					IsSelected = true
				};

				Dispatcher.BeginInvoke(() =>
				{
					newItem.IsInEditMode = true;
				});

				selectedFolder.Children.Add(newItem);
				selectedFolder.IsExpanded = true;
			}
		}

		private void TreeView_SelectionChanged(object sender, Telerik.Windows.Controls.SelectionChangedEventArgs e)
		{
			if (this.treeView1.SelectedItem != null && this.treeView1.SelectedItem is Folder)
			{
				this.addFileButton.IsEnabled = true;
				this.addFolderButton.IsEnabled = true;
			}
			else
			{
				this.addFileButton.IsEnabled = false;
				this.addFolderButton.IsEnabled = false;
			}
		}
	}
}
